﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace Grid_CollapseExpandAll
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            xamDataGrid1.DataSource = new TestDataSource();
        }

        public class TestData
        {
            public int IntegerData { get; set; }
            public string TextData { get; set; }
            public bool BoolData { get; set; }
            public TestDataSource EnumerableData { get; set; }
        }

        public class TestDataSource : ObservableCollection<TestData>
        {
            private static int _depthIndex = 5;

            public string TextDataPrefix = "data";

            public TestDataSource()
                : this(0, 5)
            {
            }

            public TestDataSource(int start, int count)
            {
                this.ResetData(start, count);
            }

            public void ResetData(int start = 0, int count = 20)
            {
                TestDataSource nestedData = null;

                _depthIndex--;

                for (int i = start; i <= start + count; i++)
                {
                    if (_depthIndex > 0)
                    {
                        nestedData = new TestDataSource();
                    }

                    this.Add(
                        new TestData()
                        {
                            IntegerData = i,
                            TextData = this.TextDataPrefix + i,
                            BoolData = true,
                            EnumerableData = nestedData
                        });

                }

                _depthIndex++;
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            if (xamDataGrid1.SelectedItems.Records.Count > 0)
            {
                
                    if (xamDataGrid1.SelectedItems.Records[0].ParentDataRecord != null)
                    {
                        xamDataGrid1.SelectedItems.Records[0].ParentDataRecord.ChildRecords[0].ChildRecords.ExpandAll(false);
                    }
                    else
                    {
                        xamDataGrid1.Records.ExpandAll(false);
                    }
                
                //foreach (DataRecord record in xamDataGrid1.SelectedItems.Records)
                //{
                //    if (record.HasChildren)
                //    {

                //        record.ChildRecords[0].ChildRecords.ExpandAll(false);
                //    }
                //}
            }
            else
            {
                xamDataGrid1.Records.ExpandAll(false);
            }
          
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            if (xamDataGrid1.SelectedItems.Records.Count > 0)
            {
                if (xamDataGrid1.SelectedItems.Records[0].ParentDataRecord != null)
                {
                    xamDataGrid1.SelectedItems.Records[0].ParentDataRecord.ChildRecords[0].ChildRecords.CollapseAll(false);
                }
                else
                {
                    xamDataGrid1.Records.CollapseAll(false);
                }
                //foreach (DataRecord record in xamDataGrid1.SelectedItems.Records)
                //{
                //    if (record.HasChildren)
                //    {
                //        record.ChildRecords[0].ChildRecords.CollapseAll(false);
                //    }
                //}
            }
            else
            {
                xamDataGrid1.Records.CollapseAll(false);
            }
        }

        private void button_Click(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.Records.ExpandAll(true);
        }

        private void button0_Click(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.Records.CollapseAll(true);
        }
    }
}
